/* settings.c generated by valac 0.32.1, the Vala compiler
 * generated from settings.vala, do not modify */

/*
 * Copyright (c) 2014 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <math.h>
#include <float.h>
#include <stdlib.h>
#include <string.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define POMODORO_TYPE_TIMER (pomodoro_timer_get_type ())
#define POMODORO_TIMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POMODORO_TYPE_TIMER, PomodoroTimer))
#define POMODORO_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POMODORO_TYPE_TIMER, PomodoroTimerClass))
#define POMODORO_IS_TIMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POMODORO_TYPE_TIMER))
#define POMODORO_IS_TIMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POMODORO_TYPE_TIMER))
#define POMODORO_TIMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POMODORO_TYPE_TIMER, PomodoroTimerClass))

typedef struct _PomodoroTimer PomodoroTimer;
typedef struct _PomodoroTimerClass PomodoroTimerClass;

#define POMODORO_TYPE_TIMER_STATE (pomodoro_timer_state_get_type ())
#define POMODORO_TIMER_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POMODORO_TYPE_TIMER_STATE, PomodoroTimerState))
#define POMODORO_TIMER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POMODORO_TYPE_TIMER_STATE, PomodoroTimerStateClass))
#define POMODORO_IS_TIMER_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POMODORO_TYPE_TIMER_STATE))
#define POMODORO_IS_TIMER_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POMODORO_TYPE_TIMER_STATE))
#define POMODORO_TIMER_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POMODORO_TYPE_TIMER_STATE, PomodoroTimerStateClass))

typedef struct _PomodoroTimerState PomodoroTimerState;
typedef struct _PomodoroTimerStateClass PomodoroTimerStateClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	POMODORO_DATE_TIME_ERROR_PARSE
} PomodoroDateTimeError;
#define POMODORO_DATE_TIME_ERROR pomodoro_date_time_error_quark ()

extern GSettings* pomodoro_settings;
GSettings* pomodoro_settings = NULL;

void pomodoro_set_settings (GSettings* settings);
GSettings* pomodoro_get_settings (void);
GType pomodoro_timer_get_type (void) G_GNUC_CONST;
void pomodoro_save_timer (PomodoroTimer* timer);
GType pomodoro_timer_state_get_type (void) G_GNUC_CONST;
PomodoroTimerState* pomodoro_timer_get_state (PomodoroTimer* self);
gdouble pomodoro_timer_state_get_timestamp (PomodoroTimerState* self);
gdouble pomodoro_timer_get_session (PomodoroTimer* self);
const gchar* pomodoro_timer_state_get_name (PomodoroTimerState* self);
gchar* pomodoro_datetime_to_string (GDateTime* datetime);
gdouble pomodoro_timer_get_offset (PomodoroTimer* self);
gdouble pomodoro_timer_state_get_duration (PomodoroTimerState* self);
void pomodoro_restore_timer (PomodoroTimer* timer);
void pomodoro_timer_stop (PomodoroTimer* self);
PomodoroTimerState* pomodoro_timer_state_lookup (const gchar* name);
void pomodoro_timer_state_set_elapsed (PomodoroTimerState* self, gdouble value);
void pomodoro_timer_state_set_duration (PomodoroTimerState* self, gdouble value);
GQuark pomodoro_date_time_error_quark (void);
GDateTime* pomodoro_datetime_from_string (const gchar* date_string, GError** error);
void pomodoro_timer_state_set_timestamp (PomodoroTimerState* self, gdouble value);
void pomodoro_timer_set_state (PomodoroTimer* self, PomodoroTimerState* value);
void pomodoro_timer_set_session (PomodoroTimer* self, gdouble value);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void pomodoro_set_settings (GSettings* settings) {
	GSettings* _tmp0_ = NULL;
	GSettings* _tmp1_ = NULL;
	g_return_if_fail (settings != NULL);
	_tmp0_ = settings;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (pomodoro_settings);
	pomodoro_settings = _tmp1_;
}


GSettings* pomodoro_get_settings (void) {
	GSettings* result = NULL;
	GSettings* _tmp0_ = NULL;
	GSettings* _tmp2_ = NULL;
	_tmp0_ = pomodoro_settings;
	if (_tmp0_ == NULL) {
		GSettings* _tmp1_ = NULL;
		_tmp1_ = g_settings_new ("org.gnome.pomodoro");
		_g_object_unref0 (pomodoro_settings);
		pomodoro_settings = _tmp1_;
	}
	_tmp2_ = pomodoro_settings;
	result = _tmp2_;
	return result;
}


void pomodoro_save_timer (PomodoroTimer* timer) {
	GSettings* state_settings = NULL;
	GSettings* _tmp0_ = NULL;
	GSettings* _tmp1_ = NULL;
	GDateTime* state_datetime = NULL;
	PomodoroTimer* _tmp2_ = NULL;
	PomodoroTimerState* _tmp3_ = NULL;
	PomodoroTimerState* _tmp4_ = NULL;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	GDateTime* _tmp8_ = NULL;
	PomodoroTimer* _tmp9_ = NULL;
	gdouble _tmp10_ = 0.0;
	gdouble _tmp11_ = 0.0;
	PomodoroTimer* _tmp12_ = NULL;
	PomodoroTimerState* _tmp13_ = NULL;
	PomodoroTimerState* _tmp14_ = NULL;
	const gchar* _tmp15_ = NULL;
	const gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	gchar* _tmp18_ = NULL;
	PomodoroTimer* _tmp19_ = NULL;
	gdouble _tmp20_ = 0.0;
	gdouble _tmp21_ = 0.0;
	PomodoroTimer* _tmp22_ = NULL;
	PomodoroTimerState* _tmp23_ = NULL;
	PomodoroTimerState* _tmp24_ = NULL;
	gdouble _tmp25_ = 0.0;
	gdouble _tmp26_ = 0.0;
	g_return_if_fail (timer != NULL);
	_tmp0_ = pomodoro_get_settings ();
	_tmp1_ = g_settings_get_child (_tmp0_, "state");
	state_settings = _tmp1_;
	_tmp2_ = timer;
	_tmp3_ = pomodoro_timer_get_state (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = pomodoro_timer_state_get_timestamp (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = floor (_tmp6_);
	_tmp8_ = g_date_time_new_from_unix_utc ((gint64) _tmp7_);
	state_datetime = _tmp8_;
	_tmp9_ = timer;
	_tmp10_ = pomodoro_timer_get_session (_tmp9_);
	_tmp11_ = _tmp10_;
	g_settings_set_double (state_settings, "session", _tmp11_);
	_tmp12_ = timer;
	_tmp13_ = pomodoro_timer_get_state (_tmp12_);
	_tmp14_ = _tmp13_;
	_tmp15_ = pomodoro_timer_state_get_name (_tmp14_);
	_tmp16_ = _tmp15_;
	g_settings_set_string (state_settings, "state", _tmp16_);
	_tmp17_ = pomodoro_datetime_to_string (state_datetime);
	_tmp18_ = _tmp17_;
	g_settings_set_string (state_settings, "state-date", _tmp18_);
	_g_free0 (_tmp18_);
	_tmp19_ = timer;
	_tmp20_ = pomodoro_timer_get_offset (_tmp19_);
	_tmp21_ = _tmp20_;
	g_settings_set_double (state_settings, "state-offset", _tmp21_);
	_tmp22_ = timer;
	_tmp23_ = pomodoro_timer_get_state (_tmp22_);
	_tmp24_ = _tmp23_;
	_tmp25_ = pomodoro_timer_state_get_duration (_tmp24_);
	_tmp26_ = _tmp25_;
	g_settings_set_double (state_settings, "state-duration", _tmp26_);
	_g_date_time_unref0 (state_datetime);
	_g_object_unref0 (state_settings);
}


void pomodoro_restore_timer (PomodoroTimer* timer) {
	PomodoroTimer* _tmp0_ = NULL;
	GSettings* state_settings = NULL;
	GSettings* _tmp1_ = NULL;
	GSettings* _tmp2_ = NULL;
	PomodoroTimerState* state = NULL;
	GSettings* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	PomodoroTimerState* _tmp6_ = NULL;
	PomodoroTimerState* _tmp7_ = NULL;
	PomodoroTimerState* _tmp8_ = NULL;
	PomodoroTimerState* _tmp23_ = NULL;
	PomodoroTimer* _tmp29_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (timer != NULL);
	_tmp0_ = timer;
	pomodoro_timer_stop (_tmp0_);
	_tmp1_ = pomodoro_get_settings ();
	_tmp2_ = g_settings_get_child (_tmp1_, "state");
	state_settings = _tmp2_;
	_tmp3_ = state_settings;
	_tmp4_ = g_settings_get_string (_tmp3_, "state");
	_tmp5_ = _tmp4_;
	_tmp6_ = pomodoro_timer_state_lookup (_tmp5_);
	_tmp7_ = _tmp6_;
	_g_free0 (_tmp5_);
	state = _tmp7_;
	_tmp8_ = state;
	if (_tmp8_ != NULL) {
		PomodoroTimerState* _tmp9_ = NULL;
		GSettings* _tmp10_ = NULL;
		gdouble _tmp11_ = 0.0;
		PomodoroTimerState* _tmp12_ = NULL;
		GSettings* _tmp13_ = NULL;
		gdouble _tmp14_ = 0.0;
		_tmp9_ = state;
		_tmp10_ = state_settings;
		_tmp11_ = g_settings_get_double (_tmp10_, "state-offset");
		pomodoro_timer_state_set_elapsed (_tmp9_, _tmp11_);
		_tmp12_ = state;
		_tmp13_ = state_settings;
		_tmp14_ = g_settings_get_double (_tmp13_, "state-duration");
		pomodoro_timer_state_set_duration (_tmp12_, _tmp14_);
		{
			gchar* state_date = NULL;
			GSettings* _tmp15_ = NULL;
			gchar* _tmp16_ = NULL;
			const gchar* _tmp17_ = NULL;
			_tmp15_ = state_settings;
			_tmp16_ = g_settings_get_string (_tmp15_, "state-date");
			state_date = _tmp16_;
			_tmp17_ = state_date;
			if (g_strcmp0 (_tmp17_, "") != 0) {
				GDateTime* state_datetime = NULL;
				const gchar* _tmp18_ = NULL;
				GDateTime* _tmp19_ = NULL;
				PomodoroTimerState* _tmp20_ = NULL;
				GDateTime* _tmp21_ = NULL;
				gint64 _tmp22_ = 0LL;
				_tmp18_ = state_date;
				_tmp19_ = pomodoro_datetime_from_string (_tmp18_, &_inner_error_);
				state_datetime = _tmp19_;
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					_g_free0 (state_date);
					if (_inner_error_->domain == POMODORO_DATE_TIME_ERROR) {
						goto __catch12_pomodoro_date_time_error;
					}
					_g_free0 (state_date);
					_g_object_unref0 (state);
					_g_object_unref0 (state_settings);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
				_tmp20_ = state;
				_tmp21_ = state_datetime;
				_tmp22_ = g_date_time_to_unix (_tmp21_);
				pomodoro_timer_state_set_timestamp (_tmp20_, (gdouble) _tmp22_);
				_g_date_time_unref0 (state_datetime);
			}
			_g_free0 (state_date);
		}
		goto __finally12;
		__catch12_pomodoro_date_time_error:
		{
			GError* _error_ = NULL;
			_error_ = _inner_error_;
			_inner_error_ = NULL;
			_g_object_unref0 (state);
			state = NULL;
			_g_error_free0 (_error_);
		}
		__finally12:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (state);
			_g_object_unref0 (state_settings);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp23_ = state;
	if (_tmp23_ != NULL) {
		PomodoroTimer* _tmp24_ = NULL;
		PomodoroTimerState* _tmp25_ = NULL;
		PomodoroTimer* _tmp26_ = NULL;
		GSettings* _tmp27_ = NULL;
		gdouble _tmp28_ = 0.0;
		_tmp24_ = timer;
		_tmp25_ = state;
		pomodoro_timer_set_state (_tmp24_, _tmp25_);
		_tmp26_ = timer;
		_tmp27_ = state_settings;
		_tmp28_ = g_settings_get_double (_tmp27_, "session");
		pomodoro_timer_set_session (_tmp26_, _tmp28_);
	} else {
		g_warning ("settings.vala:98: Could not restore time");
	}
	_tmp29_ = timer;
	g_signal_emit_by_name (_tmp29_, "update", 0.0);
	_g_object_unref0 (state);
	_g_object_unref0 (state_settings);
}



